-- ---------------------------
-- BDC_TV_SHOW_SCHEDULE
-- ---------------------------
DROP TABLE IF EXISTS BDC_TV_SHOW_SCHEDULE;
CREATE TABLE BDC_TV_SHOW_SCHEDULE
(
  ID_TV_SHOW_SCHEDULE     BIGINT(20)                  NOT NULL    AUTO_INCREMENT,
  ID_NORMALIZED_FILE      BIGINT(20)                  NOT NULL,
  ID_CHANNEL              INT(11)                     NOT NULL,
  ID_SHOW_TYPE            BIGINT(20)                  NOT NULL,
  TITLE                   VARCHAR(400),
  ORIGINAL_TITLE          VARCHAR(400),
  BEGIN_TIME              DATETIME                    NOT NULL,
  END_TIME                DATETIME                    NOT NULL,
  DURATION                INT(11),
  REPLICA                 VARCHAR(4),
  PROD_COUNTRY            VARCHAR(400),
  PROD_YEAR               VARCHAR(50),
  PRODUCTOR               VARCHAR(400),
  DIRECTOR                VARCHAR(400),
  EPISODE_TITLE           VARCHAR(400),
  EPISODE_ORIGINAL_TITLE  VARCHAR(400),
  EPISODE_NUMBER          INT(4),
  REGIONAL_OFFICE         VARCHAR(30),
  NOTE                    VARCHAR(400),
  OVERLAP                 BIT           DEFAULT 0     NOT NULL ,

  /*CAMPI PER IL CALCOLO DEI KPI*/
  SCHEDULE_YEAR           INT(4)                      NOT NULL,
  SCHEDULE_MONTH          INT(2)                      NOT NULL,
  DAYS_FROM_UPLOAD        INT(11)       DEFAULT 0     NOT NULL,

  /*CAMPI DI MONITORAGGIO*/
  CREATION_DATE           DATETIME      DEFAULT NOW() NOT NULL,
  MODIFY_DATE             DATETIME,

  PRIMARY KEY (ID_TV_SHOW_SCHEDULE)
)
COMMENT = 'Tabella per la gestione delle utilizzazioni relative alle Trasmissioni TV';

ALTER  TABLE BDC_TV_SHOW_SCHEDULE ADD CONSTRAINT FK_TV_SHOW_NORM_FILE
FOREIGN KEY (ID_NORMALIZED_FILE) REFERENCES BDC_NORMALIZED_FILE (ID_NORMALIZED_FILE);

ALTER TABLE BDC_TV_SHOW_SCHEDULE ADD CONSTRAINT FK_TV_SHOW_CHANNEL
FOREIGN KEY (ID_CHANNEL) REFERENCES bdc_canali (id);

ALTER TABLE BDC_TV_SHOW_SCHEDULE ADD CONSTRAINT FK_TV_SHOW_TYPE
FOREIGN KEY (ID_SHOW_TYPE) REFERENCES BDC_SHOW_TYPE (ID_SHOW_TYPE);

CREATE INDEX IDX_TV_SHOW_BEGIN_DATE ON BDC_TV_SHOW_SCHEDULE (BEGIN_TIME);
COMMIT;
-- ---------------------------
-- BDC_TV_SHOW_MUSIC
-- ---------------------------
DROP TABLE IF EXISTS BDC_TV_SHOW_MUSIC;
CREATE TABLE BDC_TV_SHOW_MUSIC
(
  ID_TV_SHOW_MUSIC        BIGINT(20)                  NOT NULL    AUTO_INCREMENT,
  ID_NORMALIZED_FILE      BIGINT(20)                  NOT NULL,
  ID_TV_SHOW_SCHEDULE     BIGINT(20),
  ID_MUSIC_TYPE           BIGINT(20),
  TITLE                   VARCHAR(200),
  FIRST_COMPOSER          VARCHAR(200),
  SECOND_COMPOSER         VARCHAR(200),
  DURATION                INT(11),
  REAL_DURATION           INT(11),
  NOTE                    VARCHAR(400),

  /*CAMPI PER IL CALCOLO DEI KPI*/
  DAYS_FROM_UPLOAD        INT(11)       DEFAULT 0     NOT NULL,

  /*CAMPI DI MONITORAGGIO*/
  CREATION_DATE           DATETIME      DEFAULT NOW() NOT NULL ,
  MODIFY_DATE             DATETIME,

  PRIMARY KEY (ID_TV_SHOW_MUSIC)
)
COMMENT = 'Tabella per la gestione delle utilizzazioni relative alle Opere Musicali contenute nelle Trasmissioni TV';

ALTER  TABLE BDC_TV_SHOW_MUSIC ADD CONSTRAINT FK_TV_MUSIC_NORM_FILE
FOREIGN KEY (ID_NORMALIZED_FILE) REFERENCES BDC_NORMALIZED_FILE (ID_NORMALIZED_FILE);

ALTER TABLE BDC_TV_SHOW_MUSIC ADD CONSTRAINT FK_TV_MUSIC_SHOW
FOREIGN KEY (ID_TV_SHOW_SCHEDULE) REFERENCES BDC_TV_SHOW_SCHEDULE (ID_TV_SHOW_SCHEDULE);

ALTER TABLE BDC_TV_SHOW_MUSIC ADD CONSTRAINT FK_TV_MUSIC_TYPE
FOREIGN KEY (ID_MUSIC_TYPE) REFERENCES BDC_MUSIC_TYPE (ID_MUSIC_TYPE);
COMMIT;

-- ---------------------------
-- BDC_ERR_TV_SHOW_SCHEDULE
-- ---------------------------
DROP TABLE IF EXISTS BDC_ERR_TV_SHOW_SCHEDULE;
CREATE TABLE BDC_ERR_TV_SHOW_SCHEDULE
(
  ID_ERR_TV_SHOW_SCHEDULE BIGINT(20)                  NOT NULL    AUTO_INCREMENT,
  ID_NORMALIZED_FILE      BIGINT(20)                  NOT NULL,
  ID_CHANNEL              INT(11),
  ID_SHOW_TYPE            BIGINT(20),
  TITLE                   VARCHAR(400),
  ORIGINAL_TITLE          VARCHAR(400),
  BEGIN_TIME              DATETIME,
  END_TIME                DATETIME,
  DURATION                INT(11),
  REPLICA                 VARCHAR(4),
  PROD_COUNTRY            VARCHAR(400),
  PROD_YEAR               INT(4),
  PRODUCTOR               VARCHAR(400),
  DIRECTOR                VARCHAR(400),
  EPISODE_TITLE           VARCHAR(400),
  EPISODE_ORIGINAL_TITLE  VARCHAR(400),
  EPISODE_NUMBER          INT(4),
  REGIONAL_OFFICE         VARCHAR(10),
  ERROR                   JSON,
  GLOBAL_ERROR            VARCHAR(400),
  -- CAMPI_ORIGINALI
  REPORT_CHANNEL          VARCHAR(100),
  REPORT_SHOW_TYPE        VARCHAR(100),
  REPORT_BEGIN_DATE       VARCHAR(100),
  REPORT_BEGIN_TIME       VARCHAR(100),
  REPORT_END_TIME         VARCHAR(100),
  REPORT_DURATION         VARCHAR(100),
  REPORT_PROD_YEAR        VARCHAR(100),

  /*CAMPI PER IL CALCOLO DEI KPI*/
  SCHEDULE_YEAR           INT(4),
  SCHEDULE_MONTH          INT(2),
  DAYS_FROM_UPLOAD        INT(11)       DEFAULT 0,

  /*CAMPI DI MONITORAGGIO*/
  CREATION_DATE           DATETIME      DEFAULT NOW() NOT NULL,
  MODIFY_DATE             DATETIME,

  /*AGGIUNTA POSTUMA*/
  REPORT_EPISODE_NUMBER   VARCHAR(100),

  PRIMARY KEY (ID_ERR_TV_SHOW_SCHEDULE)
)
  COMMENT = 'Tabella per la gestione delle utilizzazioni relative alle Trasmissioni TV';

ALTER  TABLE BDC_ERR_TV_SHOW_SCHEDULE ADD CONSTRAINT FK_ERR_TV_SHOW_NORM_FILE
FOREIGN KEY (ID_NORMALIZED_FILE) REFERENCES BDC_NORMALIZED_FILE(ID_NORMALIZED_FILE);

ALTER TABLE BDC_ERR_TV_SHOW_SCHEDULE ADD CONSTRAINT FK_ERR_TV_SHOW_CHANNEL
FOREIGN KEY (ID_CHANNEL) REFERENCES bdc_canali (id);

ALTER TABLE BDC_ERR_TV_SHOW_SCHEDULE ADD CONSTRAINT FK_ERR_TV_SHOW_TYPE
FOREIGN KEY (ID_SHOW_TYPE) REFERENCES BDC_SHOW_TYPE (ID_SHOW_TYPE);

CREATE INDEX IDX_ERR_TV_SHOW_BEGIN_DATE ON BDC_ERR_TV_SHOW_SCHEDULE (BEGIN_TIME);


-- ---------------------------
-- BDC_ERR_TV_SHOW_MUSIC
-- ---------------------------
DROP TABLE IF EXISTS BDC_ERR_TV_SHOW_MUSIC;
CREATE TABLE BDC_ERR_TV_SHOW_MUSIC
(
  ID_ERR_TV_SHOW_MUSIC    BIGINT(20)                  NOT NULL    AUTO_INCREMENT,
  ID_NORMALIZED_FILE      BIGINT(20)                  NOT NULL,
  ID_ERR_TV_SHOW_SCHEDULE BIGINT(20),
  ID_MUSIC_TYPE           BIGINT(20),
  TITLE                   VARCHAR(200),
  FIRST_COMPOSER          VARCHAR(200),
  SECOND_COMPOSER         VARCHAR(200),
  DURATION                INT(11),
  REAL_DURATION           INT(11),

  /* CAMPI_ORIGINALE */
  REPORT_DURATION         VARCHAR(100),
  REPORT_REAL_DURATION    VARCHAR(100),
  REPORT_MUSIC_TYPE       VARCHAR(100),

  /*CAMPI PER IL CALCOLO DEI KPI*/
  DAYS_FROM_UPLOAD        INT(11)       DEFAULT 0,

  /*CAMPI DI MONITORAGGIO*/
  CREATION_DATE           DATETIME      DEFAULT NOW() NOT NULL ,
  MODIFY_DATE             DATETIME,

  PRIMARY KEY (ID_ERR_TV_SHOW_MUSIC)
)
  COMMENT = 'Tabella per la gestione delle utilizzazioni relative alle Opere Musicali contenute nelle Trasmissioni TV';

ALTER TABLE BDC_ERR_TV_SHOW_MUSIC ADD CONSTRAINT FK_ERR_TV_MUSIC_SHOW
FOREIGN KEY (ID_ERR_TV_SHOW_SCHEDULE) REFERENCES BDC_ERR_TV_SHOW_SCHEDULE (ID_ERR_TV_SHOW_SCHEDULE);

ALTER  TABLE BDC_ERR_TV_SHOW_MUSIC ADD CONSTRAINT FK_ERR_TV_MUSIC_NORM_FILE
FOREIGN KEY (ID_NORMALIZED_FILE) REFERENCES BDC_NORMALIZED_FILE(ID_NORMALIZED_FILE);

ALTER TABLE BDC_ERR_TV_SHOW_MUSIC ADD CONSTRAINT FK_ERR_TV_MUSIC_TYPE
FOREIGN KEY (ID_MUSIC_TYPE) REFERENCES BDC_MUSIC_TYPE (ID_MUSIC_TYPE);

-- ---------------------------
-- BDC_TV_ERR_BRANO_TITOLO
-- ---------------------------
DROP TABLE IF EXISTS BDC_TV_ERR_BRANO_TITOLO;
CREATE TABLE BDC_TV_ERR_BRANO_TITOLO
(
  ID_TV_ERR_BRANO_TITOLO INT(11) NOT NULL AUTO_INCREMENT PRIMARY KEY,
  TV_ERR_BRANO_TITOLO varchar(400)
);

-- ---------------------------
-- BDC_TV_ERR_COMPOSITORE_TITOLO
-- ---------------------------
DROP TABLE IF EXISTS BDC_TV_ERR_COMPOSITORE_TITOLO;
CREATE TABLE BDC_TV_ERR_COMPOSITORE_TITOLO
(
  ID_TV_ERR_COMPOSITORE_TITOLO INT(11) NOT NULL AUTO_INCREMENT PRIMARY KEY,
  TV_ERR_COMPOSITORE_TITOLO varchar(400)
);

-- ---------------------------
-- BDC_TV_ERR_FILM_TITOLO
-- ---------------------------

DROP TABLE IF EXISTS BDC_TV_ERR_FILM_TITOLO;
CREATE TABLE BDC_TV_ERR_FILM_TITOLO
(
  ID_TV_ERR_FILM_TITOLO INT(11) NOT NULL AUTO_INCREMENT PRIMARY KEY,
  TV_ERR_FILM_TITOLO varchar(400)
);

-- ---------------------------
-- BDC_TV_ERR_PROGRAMMA_TITOLO
-- ---------------------------
DROP TABLE IF EXISTS BDC_TV_ERR_PROGRAMMA_TITOLO;
CREATE TABLE BDC_TV_ERR_PROGRAMMA_TITOLO
(
  ID_TV_ERR_PROGRAMMA_TITOLO INT(11) NOT NULL AUTO_INCREMENT PRIMARY KEY,
  TV_ERR_PROGRAMMA_TITOLO varchar(400)
);